hdu-1011 Starship Troopers

12 篇文章 0 订阅
7 篇文章 0 订阅

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 22165    Accepted Submission(s): 5869


Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.
 

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.
 

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.
 

Sample Input
 
 
5 1050 1040 1040 2065 3070 301 21 32 42 51 120 7-1 -1
 

Sample Output
 
 
507
 

Author
XU, Chuan
 

Source

题意:有一个树形洞穴,入口是1。每个洞穴有bug和brain,要到子洞穴必须将当前洞穴bugs清空。如果bugs清空则可以获得洞穴的brain。一开始你有m个士兵,每个士兵能干掉20个bugs且只能呆在一个洞穴里,问最多能获得多少brain。

题解:本题需要注意一个问题,因为士兵是不能往回走的,所以在叶子结点如果cost = 0则要将cost变为1,且如果中间节点有cost等于0的情况,需要在dfs结束时把dp[x][0]变为0,因为没有士兵经过这个点则不能接收brain。

树形dp+背包水题。注意向上取整。

设dp[i][j]为在第i个洞穴及其子洞穴,放j个士兵最多能获得多少brain。

则其转移方程为dp[x][j] = max(dp[x][j], dp[x][k] + dp[v][j - k]);

从1开始遍历即可。


AC代码

#include <stdio.h>
#include <iostream>
#include <string>
#include <queue>
#include <map>
#include <vector>
#include <algorithm>
#include <string.h>
#include <cmath>
typedef long long ll;
 
using namespace std;


const ll maxn = 1111;
ll vis[maxn];


struct node{
	ll cost, val;
}p[maxn];
ll dp[maxn][maxn];


vector<ll> s[maxn];


void dfs(ll x, ll m){
	ll len = s[x].size();
	ll cost = p[x].cost;
	if((len == 1 && cost == 0 && vis[s[x][0]]) || (len == 0 && cost == 0))
		cost = 1;
	dp[x][cost] = p[x].val;
	vector<ll> tt;
	for(ll i = 0; i < len; i++){
		if(!vis[s[x][i]]){
			tt.push_back(s[x][i]);
			vis[s[x][i]] = 1;
			dfs(s[x][i], m);
		}
	}
	len = tt.size();
	for(ll i = 0; i < len; i++){
		ll v = tt[i];
		for(ll j = m; j > cost; j--){
			for(ll k = j - 1; k >= cost; k--){
				dp[x][j] = max(dp[x][j], dp[x][k] + dp[v][j - k]);
			}
		}
	}
	dp[x][0] = 0;
}


int main(){
	ll n, m, a, b;
	while(scanf("%lld %lld", &n, &m) && (n != -1 || m != -1)){
		for(ll i = 1; i <= n; i++){
			s[i].clear();
			vis[i] = 0;
			for(ll j = 0; j <= m; j++)
				dp[i][j] = 0;
		}
		for(ll i = 1; i <= n; i++){
			scanf("%lld %lld", &p[i].cost, &p[i].val);
			p[i].cost = (p[i].cost + 19) / 20;
		}
		for(ll i = 0; i < n - 1; i++){
			scanf("%lld %lld", &a, &b);
			s[a].push_back(b);
			s[b].push_back(a);
		}
		vis[1] = true;
		dfs(1, m);
		printf("%lld\n", dp[1][m]);
		return 0;
} 
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值